Segmenttabelle:
	;	76543210  76543210
	data	0b1001000010110111	;0,1
	data	0b1011110000111110	;2,3
	data	0b1010110110011001	;4,5
	data	0b1001010010101111	;6,7
	data	0b1011110110111111	;8,9
	data	0b1010101110011111	;A,b
	data	0b1011101000100111	;C,d
	data	0b0000111100101111	;E,F

	;==========================================
lcd_init:
	sbi	DDR{lcd_clk_port},lcd_clk_bit
	sbi	DDR{lcd_dat_port},lcd_dat_bit
	sbi	DDR{lcd_ena_port},lcd_ena_bit
	ret
	;==========================================
lcd_spc:
	clr	r16
lcd_obyte:
	push	r17
	ldi	r17,8
lcd_obyte_loop:
	lsl	r16
	brlo	lcd_obyte_1	;Carry gesetzt
	cbi	PORT{lcd_dat_port},lcd_dat_bit
	rjmp	lcd_obyte_common
lcd_obyte_1:
	sbi	PORT{lcd_dat_port},lcd_dat_bit
lcd_obyte_common:
	nop
	sbi	PORT{lcd_clk_port},lcd_clk_bit
	nop
	cbi	PORT{lcd_clk_port},lcd_clk_bit
	dec	r17
	brne	lcd_obyte_loop
	pop	r17
	ret

onible:
	push	r16
	andi	r16,0x0f
	ldi 	zh,high(Segmenttabelle<<1)
	ldi 	zl,low(Segmenttabelle<<1)
	add	zl,r16
	clr	r16
	adc	zh,r16
	lpm 	r16,z
	rcall	lcd_obyte
	pop	r16
	ret

obyte:
	rcall	onible
	swap	r16
	rcall	onible
	ret

	;versuche RR24:25 durch 10 zu teilen
	;Rest aufs Display
	;Quotient in RR24:25
div:
	push	r20
	push	r21

	clr	r18	;divisor RR18:19=10<<12
	ldi	r19,0xa0
	ldi	r17,13	;Durchläufe
	clr	r20	;Quotient
	clr	r21
div1:
	lsl	r20	;Quotient linksschieben
	rol	r21
	ori	r20,1	;sein wir mal optimistisch
	sub	r24,r18
	sbc	r25,r19
	brcc	div2
	andi	r20,0b11111110	;Rollback erforderlich!
	add	r24,r18
	adc	r25,r19
div2:
	lsr	r19	;Divisor rechtsschieben
	ror	r18
	dec	r17
	brne	div1

	;R24:25 hat jetzt den Rest
	mov	r16,r24
	rcall	onible
	mov	r24,r20
	mov	r25,r21

	pop	r21
	pop	r20

	ret
